-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Chat - Customization
Use the following properties to customize the DevExtreme JavaScript Chat component:
-
To display/hide JavaScript Chat UI elements:
-
To modify date/time formats:
-
To deactivate JavaScript Chat, use the disabled property.
Backend API
$(() => {
const chat = $('#chat').dxChat({
height: 710,
items: messages,
user: currentUser,
dayHeaderFormat: dayHeaderFormats[0],
messageTimestampFormat: messageTimestampFormats[0],
onMessageEntered({ component, message }) {
component.renderMessage(message);
},
}).dxChat('instance');
$('#show-avatar').dxCheckBox({
value: true,
text: 'Avatar',
onValueChanged(data) {
chat.option('showAvatar', data.value);
},
});
$('#show-user-name').dxCheckBox({
value: true,
text: 'User Name',
onValueChanged(data) {
chat.option('showUserName', data.value);
},
});
$('#show-day-headers').dxCheckBox({
value: true,
text: 'Day Headers',
onValueChanged(data) {
chat.option('showDayHeaders', data.value);
},
});
$('#day-header-format').dxSelectBox({
items: dayHeaderFormats,
value: dayHeaderFormats[0],
inputAttr: { 'aria-label': 'Day Header Format' },
onValueChanged(data) {
chat.option('dayHeaderFormat', data.value);
},
});
$('#show-message-timestamp').dxCheckBox({
value: true,
text: 'Message Timestamp',
onValueChanged(data) {
chat.option('showMessageTimestamp', data.value);
},
});
$('#message-timestamp-format').dxSelectBox({
items: messageTimestampFormats,
value: messageTimestampFormats[0],
inputAttr: { 'aria-label': 'Message Timestamp Format' },
onValueChanged(data) {
chat.option('messageTimestampFormat', data.value);
},
});
$('#chat-disabled').dxCheckBox({
value: false,
text: 'Disable Chat',
onValueChanged(data) {
chat.option('disabled', data.value);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="js/dx.all.js?v=25.2.8"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="chat-container">
<div id="chat"></div>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div id="show-avatar"></div>
</div>
<div class="option">
<div id="show-user-name"></div>
</div>
<div class="option-separator"></div>
<div class="option">
<div id="show-day-headers"></div>
</div>
<div class="option">
<span>Day Header Format:</span>
<div id="day-header-format"></div>
</div>
<div class="option-separator"></div>
<div class="option">
<div id="show-message-timestamp"></div>
</div>
<div class="option">
<span>Message Timestamp Format:</span>
<div id="message-timestamp-format"></div>
</div>
<div class="option-separator"></div>
<div class="option">
<div id="chat-disabled"></div>
</div>
</div>
</div>
</body>
</html>
.demo-container {
min-width: 720px;
display: flex;
gap: 20px;
}
.chat-container {
display: flex;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.options {
padding: 20px;
display: flex;
flex-direction: column;
min-width: 280px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
.dx-chat {
max-width: 480px;
}
.caption {
font-size: var(--dx-font-size-sm);
font-weight: 500;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
.dx-avatar {
border: 1px solid var(--dx-color-border);
}
const getTimestamp = function (date, offsetMinutes = 0) {
return date.getTime() + offsetMinutes * 60000;
};
const date = new Date();
date.setHours(0, 0, 0, 0);
const currentUser = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
const supportAgent = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
const messages = [
{
timestamp: getTimestamp(date, -9),
author: supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: "Hi, I'm having trouble accessing my account.",
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'It says my password is incorrect.',
},
{
timestamp: getTimestamp(date, -7),
author: supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
},
{
timestamp: getTimestamp(date, 1),
author: currentUser,
text: 'john.doe1357',
},
{
timestamp: getTimestamp(date, 1),
author: supportAgent,
text: '✅ Instructions to restore access have been sent to the email address associated with your account.',
},
];
const dayHeaderFormats = ['dd/MM/yyyy', 'dd.MM.yyyy', 'MMMM dd, yyyy', 'EEEE, MMMM dd'];
const messageTimestampFormats = ['hh:mm a', 'hh:mm:ss a', 'HH:mm', 'HH:mm:ss'];

Backend API
<div class="demo-container">
<div class="chat-container">
<dx-chat
#chat
[height]="710"
[user]="currentUser"
[items]="messages$ | async"
[showAvatar]="true"
[showUserName]="true"
[showDayHeaders]="true"
[showMessageTimestamp]="true"
[dayHeaderFormat]="dayHeaderFormats[0]"
[messageTimestampFormat]="messageTimestampFormats[0]"
[disabled]="false"
(onMessageEntered)="onMessageEntered($event)"
>
</dx-chat>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box text="Avatar" [(value)]="chat.showAvatar"></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="User Name"
[(value)]="chat.showUserName"
></dx-check-box>
</div>
<div class="option-separator"></div>
<div class="option">
<dx-check-box
text="Day Headers"
[(value)]="chat.showDayHeaders"
></dx-check-box>
</div>
<div class="option">
<span>Day Header Format:</span>
<dx-select-box
[items]="dayHeaderFormats"
[(value)]="chat.dayHeaderFormat"
[inputAttr]="dayHeaderLabel"
></dx-select-box>
</div>
<div class="option-separator"></div>
<div class="option">
<dx-check-box
text="Message Timestamp"
[(value)]="chat.showMessageTimestamp"
></dx-check-box>
</div>
<div class="option">
<span>Message Timestamp Format:</span>
<dx-select-box
[items]="messageTimestampFormats"
[(value)]="chat.messageTimestampFormat"
[inputAttr]="messageTimestampLabel"
></dx-select-box>
</div>
<div class="option-separator"></div>
<div class="option">
<dx-check-box
text="Disable Chat"
[(value)]="chat.disabled"
></dx-check-box>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { AsyncPipe } from '@angular/common';
import { DxChatModule, DxCheckBoxModule, DxSelectBoxModule } from 'devextreme-angular';
import { DxChatTypes } from 'devextreme-angular/ui/chat';
import { Observable } from 'rxjs';
import { AppService } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChatModule,
DxCheckBoxModule,
DxSelectBoxModule,
AsyncPipe,
],
})
export class AppComponent {
currentUser: DxChatTypes.User;
supportAgent: DxChatTypes.User;
messages$: Observable<DxChatTypes.Message[]>;
dayHeaderFormats = this.appService.dayHeaderFormats;
messageTimestampFormats = this.appService.messageTimestampFormats;
dayHeaderLabel = this.appService.dayHeaderLabel;
messageTimestampLabel = this.appService.messageTimestampLabel;
constructor(private readonly appService: AppService) {
[this.currentUser, this.supportAgent] = this.appService.getUsers();
this.messages$ = this.appService.messages$;
}
onMessageEntered(event: DxChatTypes.MessageEnteredEvent) {
this.appService.onMessageEntered(event);
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
AppService,
],
});
.demo-container {
min-width: 720px;
display: flex;
gap: 20px;
}
::ng-deep .chat-container {
display: flex;
flex-grow: 1;
align-items: center;
justify-content: center;
}
::ng-deep .options {
padding: 20px;
display: flex;
flex-direction: column;
min-width: 280px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
::ng-deep .dx-chat {
max-width: 480px;
}
::ng-deep .caption {
font-size: var(--dx-font-size-sm);
font-weight: 500;
}
::ng-deep .option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
::ng-deep .dx-avatar {
border: 1px solid var(--dx-color-border);
}
import { Injectable } from '@angular/core';
import { Observable, BehaviorSubject } from 'rxjs';
import { DxChatTypes } from 'devextreme-angular/ui/chat';
@Injectable({
providedIn: 'root',
})
export class AppService {
date: Date;
currentUser: DxChatTypes.User = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
supportAgent: DxChatTypes.User = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
dayHeaderFormats = ['dd/MM/yyyy', 'dd.MM.yyyy', 'MMMM dd, yyyy', 'EEEE, MMMM dd'];
messageTimestampFormats = ['hh:mm a', 'hh:mm:ss a', 'HH:mm', 'HH:mm:ss'];
messageTimestampLabel = { 'aria-label': 'Message Timestamp Format' };
dayHeaderLabel = { 'aria-label': 'Day Header Format' };
messages: DxChatTypes.Message[] = [];
messagesSubject: BehaviorSubject<DxChatTypes.Message[]> = new BehaviorSubject([]);
constructor() {
this.date = new Date();
this.date.setHours(0, 0, 0, 0);
this.messages = [
{
timestamp: this.getTimestamp(this.date, -9),
author: this.supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
timestamp: this.getTimestamp(this.date, -7),
author: this.currentUser,
text: 'Hi, I\'m having trouble accessing my account.',
},
{
timestamp: this.getTimestamp(this.date, -7),
author: this.currentUser,
text: 'It says my password is incorrect.',
},
{
timestamp: this.getTimestamp(this.date, -7),
author: this.supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
},
{
timestamp: this.getTimestamp(this.date, 1),
author: this.currentUser,
text: 'john.doe1357',
},
{
timestamp: this.getTimestamp(this.date, 1),
author: this.supportAgent,
text: '✅ Instructions to restore access have been sent to the email address associated with your account.',
},
];
this.messagesSubject.next(this.messages);
}
get messages$(): Observable<DxChatTypes.Message[]> {
return this.messagesSubject.asObservable();
}
getUsers(): DxChatTypes.User[] {
return [this.currentUser, this.supportAgent];
}
getTimestamp(date: Date, offsetMinutes = 0): number {
return date.getTime() + offsetMinutes * 60000;
}
onMessageEntered(event: DxChatTypes.MessageEnteredEvent) {
this.messages = [...this.messages, event.message];
this.messagesSubject.next(this.messages);
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
<template>
<div class="chat-container">
<DxChat
:height="710"
v-model:items="messages"
v-model:user="currentUser"
v-model:disabled="isDisabled"
v-model:showAvatar="showAvatar"
v-model:showUserName="showUsername"
v-model:showDayHeaders="showDayHeaders"
v-model:showMessageTimestamp="showMessageTime"
v-model:dayHeaderFormat="dayHeaderFormat"
v-model:messageTimestampFormat="messageTimestampFormat"
@message-entered="onMessageEntered($event)"
/>
</div>
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="showAvatar"
text="Avatar"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="showUsername"
text="User Name"
/>
</div>
<div class="option-separator"/>
<div class="option">
<DxCheckBox
v-model:value="showDayHeaders"
:input-attr="dayHeaderLabel"
text="Day Headers"
/>
</div>
<div class="option">
<span>Day Header Format:</span>
<DxSelectBox
:items="headerFormats"
:input-attr="dayHeaderLabel"
v-model:value="dayHeaderFormat"
/>
</div>
<div class="option-separator"/>
<div class="option">
<DxCheckBox
v-model:value="showMessageTime"
text="Message Timestamp"
/>
</div>
<div class="option">
<span>Message Timestamp Format:</span>
<DxSelectBox
:items="messageFormats"
:input-attr="messageTimestampLabel"
v-model:value="messageTimestampFormat"
/>
</div>
<div class="option-separator"/>
<div class="option">
<DxCheckBox
v-model:value="isDisabled"
text="Disable Chat"
/>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxChat, { type DxChatTypes } from 'devextreme-vue/chat';
import DxCheckBox from 'devextreme-vue/check-box';
import DxSelectBox from 'devextreme-vue/select-box';
import {
messages as initialMessages,
currentUser,
dayHeaderFormats as headerFormats,
messageTimestampFormats as messageFormats,
messageTimestampLabel,
dayHeaderLabel,
} from './data.ts';
const messages = ref(initialMessages);
const showAvatar = ref(true);
const showUsername = ref(true);
const showDayHeaders = ref(true);
const showMessageTime = ref(true);
const dayHeaderFormat = ref(headerFormats[0]);
const messageTimestampFormat = ref(messageFormats[0]);
const isDisabled = ref(false);
function onMessageEntered(event: DxChatTypes.MessageEnteredEvent): void {
messages.value = [...messages.value, event.message];
}
</script>
<style scoped>
#app {
min-width: 720px;
display: flex;
gap: 20px;
}
.chat-container {
display: flex;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.options {
padding: 20px;
display: flex;
flex-direction: column;
min-width: 280px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
.dx-chat {
max-width: 480px;
}
.caption {
font-size: var(--dx-font-size-sm);
font-weight: 500;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
.dx-avatar {
border: 1px solid var(--dx-color-border);
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import type { DxChatTypes } from "devextreme-vue/chat";
const date = new Date();
date.setHours(0, 0, 0, 0);
function getTimestamp(date: Date, offsetMinutes: number = 0) {
return date.getTime() + offsetMinutes * 60000;
}
export const currentUser = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
export const supportAgent = {
id: 'd16d1a4c-5c67-4e20-b7v0e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
export const messages: DxChatTypes.Message[] = [
{
timestamp: getTimestamp(date, -9),
author: supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'Hi, I\'m having trouble accessing my account.',
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'It says my password is incorrect.',
},
{
timestamp: getTimestamp(date, -7),
author: supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
},
{
timestamp: getTimestamp(date, 1),
author: currentUser,
text: 'john.doe1357',
},
{
timestamp: getTimestamp(date, 1),
author: supportAgent,
text: '✅ Instructions to restore access have been sent to the email address associated with your account.',
},
];
export const dayHeaderFormats = ['dd/MM/yyyy', 'dd.MM.yyyy', 'MMMM dd, yyyy', 'EEEE, MMMM dd'];
export const messageTimestampFormats = ['hh:mm a', 'hh:mm:ss a', 'HH:mm', 'HH:mm:ss'];
export const messageTimestampLabel = { 'aria-label': 'Message Timestamp Format' };
export const dayHeaderLabel = { 'aria-label': 'Day Header Format' };
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>

Backend API
import React, { useState, useCallback } from 'react';
import Chat from 'devextreme-react/chat';
import type { ChatTypes } from 'devextreme-react/chat';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import type { CheckBoxTypes } from 'devextreme-react/check-box';
import type { Format } from 'devextreme-react/common/core/localization';
import {
currentUser,
messages as initialMessages,
dayHeaderFormats as headerFormats,
messageTimestampFormats as messageTimestamps,
messageTimestampLabel,
dayHeaderLabel,
} from './data.ts';
type CheckBoxValue = CheckBoxTypes.Properties['value'];
export default function App() {
const [messages, setMessages] = useState<ChatTypes.Message[]>(initialMessages);
const [showAvatar, setShowAvatar] = useState<CheckBoxValue>(true);
const [showUsername, setShowUsername] = useState<CheckBoxValue>(true);
const [showDayHeaders, setDayHeaders] = useState<CheckBoxValue>(true);
const [dayHeaderFormat, setDayHeaderFormat] = useState<Format>(headerFormats[0]);
const [showMessageTimestamp, setMessageTimestamp] = useState<CheckBoxValue>(true);
const [messageTimestampFormat, setMessageTimestampFormat] = useState<Format>(messageTimestamps[0]);
const [isDisabled, setDisabled] = useState<CheckBoxTypes.Properties['value']>(false);
const onMessageEntered = useCallback(({ message }: ChatTypes.MessageEnteredEvent): void => {
setMessages((prevMessages) => [...prevMessages, message]);
}, []);
return (
<>
<div className="chat-container">
<Chat
height={710}
items={messages}
user={currentUser}
disabled={!!isDisabled}
showAvatar={!!showAvatar}
showUserName={!!showUsername}
showDayHeaders={!!showDayHeaders}
showMessageTimestamp={!!showMessageTimestamp}
dayHeaderFormat={dayHeaderFormat}
messageTimestampFormat={messageTimestampFormat}
onMessageEntered={onMessageEntered}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Avatar"
value={showAvatar}
onValueChange={setShowAvatar}
/>
</div>
<div className="option">
<CheckBox
text="User Name"
value={showUsername}
onValueChange={setShowUsername}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
text="Day Headers"
value={showDayHeaders}
onValueChange={setDayHeaders}
/>
</div>
<div className="option">
<span>Day Header Format:</span>
<SelectBox
items={headerFormats}
value={dayHeaderFormat}
inputAttr={dayHeaderLabel}
onValueChange={setDayHeaderFormat}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
text="Message Timestamp"
value={showMessageTimestamp}
onValueChange={setMessageTimestamp}
/>
</div>
<div className="option">
<span>Message Timestamp Format:</span>
<SelectBox
items={messageTimestamps}
value={messageTimestampFormat}
inputAttr= {messageTimestampLabel}
onValueChange={setMessageTimestampFormat}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
text="Disable Chat"
value={isDisabled}
onValueChange={setDisabled}
/>
</div>
</div>
</>
);
}
import React, { useState, useCallback } from 'react';
import Chat from 'devextreme-react/chat';
import SelectBox from 'devextreme-react/select-box';
import CheckBox from 'devextreme-react/check-box';
import {
currentUser,
messages as initialMessages,
dayHeaderFormats as headerFormats,
messageTimestampFormats as messageTimestamps,
messageTimestampLabel,
dayHeaderLabel,
} from './data.js';
export default function App() {
const [messages, setMessages] = useState(initialMessages);
const [showAvatar, setShowAvatar] = useState(true);
const [showUsername, setShowUsername] = useState(true);
const [showDayHeaders, setDayHeaders] = useState(true);
const [dayHeaderFormat, setDayHeaderFormat] = useState(headerFormats[0]);
const [showMessageTimestamp, setMessageTimestamp] = useState(true);
const [messageTimestampFormat, setMessageTimestampFormat] = useState(messageTimestamps[0]);
const [isDisabled, setDisabled] = useState(false);
const onMessageEntered = useCallback(({ message }) => {
setMessages((prevMessages) => [...prevMessages, message]);
}, []);
return (
<>
<div className="chat-container">
<Chat
height={710}
items={messages}
user={currentUser}
disabled={!!isDisabled}
showAvatar={!!showAvatar}
showUserName={!!showUsername}
showDayHeaders={!!showDayHeaders}
showMessageTimestamp={!!showMessageTimestamp}
dayHeaderFormat={dayHeaderFormat}
messageTimestampFormat={messageTimestampFormat}
onMessageEntered={onMessageEntered}
/>
</div>
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Avatar"
value={showAvatar}
onValueChange={setShowAvatar}
/>
</div>
<div className="option">
<CheckBox
text="User Name"
value={showUsername}
onValueChange={setShowUsername}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
text="Day Headers"
value={showDayHeaders}
onValueChange={setDayHeaders}
/>
</div>
<div className="option">
<span>Day Header Format:</span>
<SelectBox
items={headerFormats}
value={dayHeaderFormat}
inputAttr={dayHeaderLabel}
onValueChange={setDayHeaderFormat}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
text="Message Timestamp"
value={showMessageTimestamp}
onValueChange={setMessageTimestamp}
/>
</div>
<div className="option">
<span>Message Timestamp Format:</span>
<SelectBox
items={messageTimestamps}
value={messageTimestampFormat}
inputAttr={messageTimestampLabel}
onValueChange={setMessageTimestampFormat}
/>
</div>
<div className="option-separator"></div>
<div className="option">
<CheckBox
text="Disable Chat"
value={isDisabled}
onValueChange={setDisabled}
/>
</div>
</div>
</>
);
}
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { ChatTypes } from 'devextreme-react/chat';
import type { Format } from 'devextreme-react/common/core/localization';
function getTimestamp(date: Date, offsetMinutes = 0) {
return date.getTime() + offsetMinutes * 60000;
}
const date = new Date();
date.setHours(0, 0, 0, 0);
export const currentUser: ChatTypes.User = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
export const supportAgent: ChatTypes.User = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
export const messages: ChatTypes.Message[] = [
{
timestamp: getTimestamp(date, -9),
author: supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'Hi, I\'m having trouble accessing my account.',
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'It says my password is incorrect.',
},
{
timestamp: getTimestamp(date, -7),
author: supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
},
{
timestamp: getTimestamp(date, 1),
author: currentUser,
text: 'john.doe1357',
},
{
timestamp: getTimestamp(date, 1),
author: supportAgent,
text: '✅ Instructions to restore access have been sent to the email address associated with your account.',
},
];
export const dayHeaderFormats: Format[] = ['dd/MM/yyyy', 'dd.MM.yyyy', 'MMMM dd, yyyy', 'EEEE, MMMM dd'];
export const messageTimestampFormats: Format[] = ['hh:mm a', 'hh:mm:ss a', 'HH:mm', 'HH:mm:ss'];
export const messageTimestampLabel = { 'aria-label': 'Message Timestamp Format' };
export const dayHeaderLabel = { 'aria-label': 'Day Header Format' };
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
function getTimestamp(date, offsetMinutes = 0) {
return date.getTime() + offsetMinutes * 60000;
}
const date = new Date();
date.setHours(0, 0, 0, 0);
export const currentUser = {
id: 'c94c0e76-fb49-4b9b-8f07-9f93ed93b4f3',
name: 'John Doe',
};
export const supportAgent = {
id: 'd16d1a4c-5c67-4e20-b70e-2991c22747c3',
name: 'Support Agent',
avatarUrl: '../../../../images/petersmith.png',
};
export const messages = [
{
timestamp: getTimestamp(date, -9),
author: supportAgent,
text: 'Hello, John!\nHow can I assist you today?',
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: "Hi, I'm having trouble accessing my account.",
},
{
timestamp: getTimestamp(date, -7),
author: currentUser,
text: 'It says my password is incorrect.',
},
{
timestamp: getTimestamp(date, -7),
author: supportAgent,
text: 'I can help you with that. Can you please confirm your UserID for security purposes?',
},
{
timestamp: getTimestamp(date, 1),
author: currentUser,
text: 'john.doe1357',
},
{
timestamp: getTimestamp(date, 1),
author: supportAgent,
text: '✅ Instructions to restore access have been sent to the email address associated with your account.',
},
];
export const dayHeaderFormats = ['dd/MM/yyyy', 'dd.MM.yyyy', 'MMMM dd, yyyy', 'EEEE, MMMM dd'];
export const messageTimestampFormats = ['hh:mm a', 'hh:mm:ss a', 'HH:mm', 'HH:mm:ss'];
export const messageTimestampLabel = { 'aria-label': 'Message Timestamp Format' };
export const dayHeaderLabel = { 'aria-label': 'Day Header Format' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#app {
min-width: 720px;
display: flex;
gap: 20px;
}
.chat-container {
display: flex;
flex-grow: 1;
align-items: center;
justify-content: center;
}
.options {
padding: 20px;
display: flex;
flex-direction: column;
min-width: 280px;
background-color: rgba(191, 191, 191, 0.15);
gap: 16px;
}
.dx-chat {
max-width: 480px;
}
.caption {
font-size: var(--dx-font-size-sm);
font-weight: 500;
}
.option-separator {
border-bottom: 1px solid var(--dx-color-border);
}
.dx-avatar {
border: 1px solid var(--dx-color-border);
}